# -*- encoding: utf-8 -*-
from __future__ import unicode_literals

import mwparserfromhell
import re
import json
import pywikibot
from pywikibot import xmlreader
from mwparserfromhell.parser import ParserError
from wikiciteparser.parser import parse_citation_template

citations = []

dump = xmlreader.XmlDump('enwiki-20160501-pages-articles-multistream.xml')

for idx, page in enumerate(dump.parse()):
    text = page.text

    try:
        wikicode = mwparserfromhell.parse(text)
    except (ValueError, ParserError):
        continue

    for tpl in wikicode.filter_templates():
        parsed = parse_citation_template(tpl)
        if parsed:
            print '\t'.join([
                page.revisionid,
                page.id,
                page.timestamp,
                page.title,
                unicode(tpl.name),
                json.dumps(parsed)
            ]).encode('utf-8')


